DataNodeLayoutVersion.Feature (Apache Hadoop Main 3.5.0 API)
Description: declaration: package: org.apache.hadoop.hdfs.server.datanode, class: DataNodeLayoutVersion, enum: Feature

Package org.apache.hadoop.hdfs.server.datanode

# Enum Class DataNodeLayoutVersion.Feature

java.lang.Object
java.lang.Enum<DataNodeLayoutVersion.Feature>
org.apache.hadoop.hdfs.server.datanode.DataNodeLayoutVersion.Feature

All Implemented Interfaces:
  `Serializable`, `Comparable<DataNodeLayoutVersion.Feature>`, `Constable`, `org.apache.hadoop.hdfs.protocol.LayoutVersion.LayoutFeature`

Enclosing class:
  org.apache.hadoop.hdfs.server.datanode.DataNodeLayoutVersion

public static enum DataNodeLayoutVersion.Feature extends Enum<DataNodeLayoutVersion.Feature> implements org.apache.hadoop.hdfs.protocol.LayoutVersion.LayoutFeature
Enums for features that change the layout version.
To add a new layout version:

- Define a new enum constant with a short enum name, the new layout version and description of the added feature.
- When adding a layout version with an ancestor that is not same as its immediate predecessor, use the constructor where a specific ancestor can be passed.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `BLOCKID_BASED_LAYOUT`
  `BLOCKID_BASED_LAYOUT_32_by_32`
  `FIRST_LAYOUT`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `org.apache.hadoop.hdfs.protocol.LayoutVersion.FeatureInfo`
  `getInfo()`
  `static DataNodeLayoutVersion.Feature`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static DataNodeLayoutVersion.Feature[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### FIRST_LAYOUT

    public static final DataNodeLayoutVersion.Feature FIRST_LAYOUT

  - ### BLOCKID_BASED_LAYOUT

    public static final DataNodeLayoutVersion.Feature BLOCKID_BASED_LAYOUT

  - ### BLOCKID_BASED_LAYOUT_32_by_32

    public static final DataNodeLayoutVersion.Feature BLOCKID_BASED_LAYOUT_32_by_32

- ## Method Details

  - ### values

    public static DataNodeLayoutVersion.Feature[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static DataNodeLayoutVersion.Feature valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getInfo

    public org.apache.hadoop.hdfs.protocol.LayoutVersion.FeatureInfo getInfo()
    Specified by:
      `getInfo` in interface `org.apache.hadoop.hdfs.protocol.LayoutVersion.LayoutFeature`